<div align="center">
<img src="https://user-images.githubusercontent.com/50536495/170400421-0c3a1711-4484-42b1-995b-ee0095c3c7cb.png" width = "210" height = "210" alt="Get it on F-Droid"/>
  <h1>PixaPencil</a></h1>
  <p>A capable — Kotlin-first — pixel art editor for Android.</p>


[![Discord](https://img.shields.io/badge/Discord-PixaPencil-blue.svg)](https://discord.com/invite/Ytm7WBMNz9)
[![Matrix](https://img.shields.io/badge/Matrix-PixaPencil-green.svg)](https://matrix.to/#/#pixapencil:matrix.org)
[![License](https://img.shields.io/badge/License-MIT-red.svg)](https://choosealicense.com/licenses/mit/)

[<img src="https://github.com/machiav3lli/oandbackupx/blob/034b226cea5c1b30eb4f6a6f313e4dadcbb0ece4/badge_github.png" alt="Get it on GitHub" height="80">](https://github.com/therealbluepandabear/PixaPencil/releases/latest)
</div>

## 📱 Android market
**PixaPencil** will be available soon on the Google Play Store and F-Droid, as well as a .apk file.

_A stable release (v0.0.1) is expected to release in a week or two._

## ▶️ Video
https://www.youtube.com/watch?v=Y77EkLLC8Lo&ab_channel=thebluepandabear

## 👨‍💻 Open issues
Anyone can contribute to this app by opening a pull request, but I prefer if it is only to address any sort of bug or the two issues I will state below.

Here are two important issues that I have not been able to fix on my own:

- _Translation:_ the app is only available in English. If you can translate the app into other languages please send me an email at **therealbluepandabear@gmail.com**.

- _Large canvas grid problem:_ the grid tool works OK for smaller canvas sizes but struggles when the canvas size gets large as the lines become too thick. If anyone has any ideas how to fix this feel free to open a pull request or send me an email at **therealbluepandabear@gmail.com**. Note that this is a minor issue, as most people aren't going to be using the app for large canvas sizes, but it would be nice to fix.

## 🖼️ Showcase

_Symmetrical art (PixaPencil has powerful symmetry capabilities that haven't been seen in other mobile pixel art editors):_

![image](https://user-images.githubusercontent.com/50536495/164863846-a2616e20-e7d1-4cf8-a659-ce0ab43586a0.png)
![image](https://user-images.githubusercontent.com/50536495/164864089-84f657b4-c08a-4dd2-bde5-560a4c78e3f1.png)

![image](https://user-images.githubusercontent.com/50536495/164866012-fa1ce32f-aa80-41cc-887c-94ddf09d33f3.png)
![image](https://user-images.githubusercontent.com/50536495/164866021-b992b5e6-b1ff-49f8-a77b-91feab887b23.png)

![image](https://user-images.githubusercontent.com/50536495/164867306-ed7262f8-e33b-45d3-8e04-8ff122d845ba.png)
![image](https://user-images.githubusercontent.com/50536495/164867362-bda11589-5bae-4872-b927-397875b0d35a.png)

_Minecraft diamond sword:_

![image](https://user-images.githubusercontent.com/50536495/152713363-a873fdd3-ecc6-4939-a495-28c4a35abbdb.png)
![image](https://user-images.githubusercontent.com/50536495/152713464-9049586a-2332-4625-b31d-99d822625879.png)

**If you want to showcase an image of your own please send me an email at therealbluepandabear@gmail.com.**

## 📜 License

To disclaim, this repository is licensed under the MIT license.

For more info go to: https://choosealicense.com/licenses/mit/.

_Do not use the name '**PixaPencil**' in your app/other product._

## 📝 Features (as of March 29, 2022)
- Pencil tool (https://youtu.be/Y77EkLLC8Lo?t=20)
- Fill tool (https://youtu.be/Y77EkLLC8Lo?t=39)
- Vertical mirror tool (https://youtu.be/Y77EkLLC8Lo?t=57)
- Horizontal mirror tool (https://youtu.be/Y77EkLLC8Lo?t=82)
- Line tool (https://youtu.be/Y77EkLLC8Lo?t=94)
- Rectangle tool (https://youtu.be/Y77EkLLC8Lo?t=121)
- Outlined rectangle tool (n/a)
- Square tool (https://youtu.be/Y77EkLLC8Lo?t=149)
- Outlined square tool (n/a)
- Circle Tool (https://youtu.be/Y77EkLLC8Lo?t=164)
- Outlined Circle Tool (n/a)
- Spray tool (https://youtu.be/Y77EkLLC8Lo?t=197)
- Polygon tool (https://youtu.be/Y77EkLLC8Lo?t=247)
- Dither tool (https://youtu.be/Y77EkLLC8Lo?t=269)
- Darkening tool (https://youtu.be/Y77EkLLC8Lo?t=286) **[Outdated - Merged into one tool]**
- Lightening tool (https://youtu.be/Y77EkLLC8Lo?t=314) **[Outdated - Merged into one tool]**
- Clear canvas tool (https://youtu.be/Y77EkLLC8Lo?t=344)
- Picker tool (https://youtu.be/Y77EkLLC8Lo?t=350) 
- Find and replace by color tool (https://youtu.be/Y77EkLLC8Lo?t=361) **[Partially Outdated]**
- Eraser tool (n/a)
- Pixel grid (can be disabled or enabled) (n/a)
- Pixel perfect mode (not 100% stable) (https://youtu.be/Y77EkLLC8Lo?t=623)
- Undo (https://youtu.be/Y77EkLLC8Lo?t=570)
- Redo (https://youtu.be/Y77EkLLC8Lo?t=571)
- Zoom in (https://youtu.be/Y77EkLLC8Lo?t=559)
- Zoom out (https://youtu.be/Y77EkLLC8Lo?t=562)
- Canvas filters (https://youtu.be/Y77EkLLC8Lo?t=403)
- Custom color palettes (https://youtu.be/Y77EkLLC8Lo?t=457)
- Brushes (https://youtu.be/Y77EkLLC8Lo?t=496)
- Ability to select custom colors (https://youtu.be/Y77EkLLC8Lo?t=458) **[Outdated]**
- Ability to unfavorite/favorite projects (https://youtu.be/Y77EkLLC8Lo?t=659)
- Ability to export projects to a PNG/JPG file (https://youtu.be/Y77EkLLC8Lo?t=601)
- Ability to rotate the canvas 90 degrees clockwise and anti-clockwise, as well as 180 degrees (https://youtu.be/Y77EkLLC8Lo?t=538)

Go to https://github.com/therealbluepandabear/PixaPencil/projects to have a look at features we want to add to **PixaPencil**.

# 📓 Translations
If you spot issues with the translation send me an email at therealbluepandabear@gmail.com or open an issue request.

This app has been translated to:
- 🇮🇱 Hebrew (by myself), the translation quality is OK.
- 🇫🇷 French (by a user who has wished to remain anonymous), I am unsure about the translation quality, but it should be OK.
- Arabic (by ManeraKai [https://github.com/ManeraKai])

## 📣 Shoutout
Thank you to:
- _JohnWick_007#8119 on Discord for providing me some icons to use in my app._ **(This user's contribution is no longer in the app.)**
- _PapaBread#3820 on Discord for helping me out with the mathematics required to add a mirror tool into the app._ **(This user's contribution is no longer in the app.)**
- And, most importantly - those on StackOverflow who have assisted me with the many bugs I have encountered in my app.

## 📚 Other libraries used
Without these libraries, this app would not have been possible, so please check them out:

- duanhong169 (https://github.com/duanhong169) - ColorPicker (https://github.com/duanhong169/ColorPicker)
- yshrsmz (https://github.com/yshrsmz) - KeyboardVisibilityEvent (https://github.com/yshrsmz/KeyboardVisibilityEvent) 


